﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2015 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Linq;
using System.Windows.Forms;
using HeuristicLab.Common;
using HeuristicLab.Data;
using HeuristicLab.MainForm;
using HeuristicLab.MainForm.WindowsForms;
using HeuristicLab.Optimization;
using HeuristicLab.Problems.DataAnalysis;
using HeuristicLab.Problems.DataAnalysis.Symbolic;
using HeuristicLab.Problems.DataAnalysis.Symbolic.Regression;


namespace HeuristicLab.VariableInteractionNetworks.Views
{
    [View("VariableInteractionNetworkView")]
    [Content(typeof(RunCollection), IsDefaultView = false)]
    public sealed partial class VariableInteractionNetworkView : AsynchronousContentView
    {
        public new RunCollection Content
        {
            get { return (RunCollection)base.Content; }
            set { base.Content = value; }
        }

        public VariableInteractionNetworkView()
        {
            InitializeComponent();
            CalculateVariableInteractions();
        }

        protected override void DeregisterContentEvents()
        {
            // TODO: Deregister your event handlers here
            base.DeregisterContentEvents();
        }

        protected override void RegisterContentEvents()
        {
            base.RegisterContentEvents();
            // TODO: Register your event handlers here
        }

        #region Event Handlers (Content)
        // TODO: Put event handlers of the content here
        #endregion

        protected override void OnContentChanged()
        {
            base.OnContentChanged();
            if (Content == null)
            {
                // TODO: Add code when content has been changed and is null
            }
            else
            {
                // TODO: Add code when content has been changed and is not null
            }
        }


        protected override void SetEnabledStateOfControls()
        {
            base.SetEnabledStateOfControls();
            // TODO: Enable or disable controls based on whether the content is null or the view is set readonly
        }

        #region Event Handlers (child controls)
        // TODO: Put event handlers of child controls here.
        #endregion

        private void CalculateVariableInteractions()
        {
            var runCollection = Content;

            foreach (var g in runCollection.GroupBy(x => ((IRegressionProblem)x.Algorithm.Problem).ProblemData.TargetVariable))
            {
                CalculateVariableNetwork(g);
            }
        }

        private void CalculateVariableNetwork(IEnumerable<IRun> runs)
        {

        }
    }
}